// HScr2ClpDlg.cpp : implementation file
//

#include "stdafx.h"
#include "HScr2Clp.h"
#include "HScr2ClpDlg.h"

__declspec(dllimport) BOOL InstallKBHook(HWND hWnd);
__declspec(dllimport) BOOL UnInstallKBHook(HWND hWnd);
static UINT	UWM_ClickPrnScrn = ::RegisterWindowMessage("UWM_ClickPrintScreen_B2ABC742-0A63-49c3-9ACB-CF0068027A66");


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA	
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHScr2ClpDlg dialog

CHScr2ClpDlg::CHScr2ClpDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CHScr2ClpDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CHScr2ClpDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CHScr2ClpDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_Mail, m_Mail);
	//{{AFX_DATA_MAP(CHScr2ClpDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CHScr2ClpDlg, CDialog)
	ON_REGISTERED_MESSAGE(UWM_ClickPrnScrn, OnClickPrintScreen)
	//{{AFX_MSG_MAP(CHScr2ClpDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CLOSE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHScr2ClpDlg message handlers

BOOL CHScr2ClpDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// get current placement
	GetWindowPlacement(&m_wndPlace);
	GetWindowRect(&m_rectWnd);

	m_bIsEnableCapture = FALSE;
	m_bIsTrackingMouseMove = FALSE;
	m_ptFirst = m_ptLast = NULL;

	// set Mailto info
	// Ref: Chris Maunder, TrayCalendar
	m_Mail.SetURL(_T("mailto:yinghsuan_h@yahoo.com?Subject=Screen 2 Clipboard"));
	m_Mail.SetColours(m_Mail.GetLinkColour(),m_Mail.GetLinkColour());
	m_Mail.SetLinkCursor(AfxGetApp()->LoadCursor(_T("res/H_POINT.cur")));
	::SetCursor(::LoadCursor(NULL, IDC_ARROW));

	// register keyboard Hook	
	if(!InstallKBHook(m_hWnd))
	{
		AfxMessageBox(_T("Failed: Hook keyboard event"));
		exit(1);
	}
	else
		TRACE(_T("\n\tSucceeded: Hook keyboard\n"));

	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CHScr2ClpDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CHScr2ClpDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CHScr2ClpDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CHScr2ClpDlg::OnClose() 
{
	// unhook before close
	if( !UnInstallKBHook(m_hWnd))
		AfxMessageBox(_T("Failed: unhook keybaord"));
	else
		TRACE(_T("\n\tSucceeded: Unhook keyboard\n"));

	CDialog::OnClose();
}

//////////////////////////////////////////////////////////////////////////////
// Catch "PrintScreen" click event
// 1. read image from clipboard
// 2. re-size app to draw image
// 3. set app on MostTop Z-order
// 4. fire "SetCapture"
BOOL CHScr2ClpDlg::OnClickPrintScreen(WPARAM wParam, LPARAM lParam)
{
	TRACE(_T("\n\nSucceeded: Got msg from Callback::OnClickPrintScreen\n"));
	
	GetWindowRect(&m_rectWnd);
	m_dwWndStyle = GetStyle();
	if(IsClipboardFormatAvailable(CF_BITMAP) && OpenClipboard())
	{
		HBITMAP hBm;
		CBitmap cBm;
		hBm = (HBITMAP)GetClipboardData(CF_BITMAP);		 
		CloseClipboard();
		if(hBm == NULL)
		{
			 AfxMessageBox(_T("Failed: Read data from clipboard."));
			 return FALSE;
		}
		if(!cBm.Attach(hBm))
		{
			AfxMessageBox(_T("Failed: Attach Clipboard image."));
			return FALSE;
		}
		BITMAP bBm;
		if(!cBm.GetBitmap(&bBm))
		{
			AfxMessageBox(_T("Failed: GetBitmap"));
			return FALSE;
		}
		ShowMsg(FALSE);
		SetWindowPlacement(&m_wndPlace);
		ModifyStyle(WS_BORDER,0);
		SetWindowPos(&wndTopMost,0,0,bBm.bmWidth,bBm.bmHeight,SWP_SHOWWINDOW);
		CClientDC dcScreen(this);
		CDC dcMem;
		dcMem.CreateCompatibleDC(&dcScreen);
		CBitmap* pOldBitmap = dcMem.SelectObject(&cBm);
		dcScreen.BitBlt(0,0,bBm.bmWidth,bBm.bmHeight ,&dcMem,0,0,SRCCOPY);
		dcMem.SelectObject(pOldBitmap);		
		cBm.Detach();
		m_bIsEnableCapture = TRUE;// "SetCapture" falg
		m_uintRecording = SetTimer(ID_RecordingTimer,500,NULL);
		return TRUE;
	}
	return FALSE;
}

////////////////////////////////////////////////////////////////////////////
// if it's "SetCapture", draw rectangle until release
void CHScr2ClpDlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
	if( m_bIsEnableCapture)
	{
		SetCapture();
		m_bIsTrackingMouseMove = TRUE;
		m_ptFirst = m_ptLast = point;
		CClientDC dcScrn(this); // draw on client area
		InvertRectLine(&dcScrn,m_ptFirst,m_ptLast);
	}
	
	CDialog::OnLButtonDown(nFlags, point);
}


///////////////////////////////////////////////////////////////////////////
// if it's "SetCapture", send Image to clipboard
void CHScr2ClpDlg::OnLButtonUp(UINT nFlags, CPoint point) 
{
	if( m_bIsEnableCapture)
	{
		m_ptLast = point;
		CClientDC dcScrn(this);
		InvertRectLine(&dcScrn,m_ptFirst,m_ptLast);
		CopyRect2Clipboard();
		m_ptFirst = m_ptLast = NULL;
		m_bIsEnableCapture = FALSE;
		m_bIsTrackingMouseMove = FALSE;
		if( GetCapture() == this)
			ASSERT(ReleaseCapture());		
		KillTimer(ID_RecordingTimer);
		ModifyStyle(0,m_dwWndStyle);
		SetWindowPos(&wndTop,		// may put it behinde others
					 m_rectWnd.left,
					 m_rectWnd.top ,
					 m_rectWnd.Width(),
					 m_rectWnd.Height(),
					 SWP_SHOWWINDOW);
		BringWindowToTop();			// bring to top to show msg	
		ShowMsg(TRUE);
		Invalidate(TRUE);
	}	
	
	CDialog::OnLButtonUp(nFlags, point);
}

/////////////////////////////////////////////////////////////////////////
// invert borderlines of Rect(ptFrom, ptTo)
BOOL CHScr2ClpDlg::InvertRectLine(CDC *pDc, CPoint ptFrom, CPoint ptTo)
{
	//use R2_NOT to invert line
	int nOldMode = pDc->SetROP2(R2_NOT);
	CRect rect(ptFrom, ptTo);
	CPoint pts[] ={ CPoint(rect.left,rect.top),		// LT
					CPoint(rect.right,rect.top),	// RT
					CPoint(rect.right,rect.bottom), // RB
					CPoint(rect.left,rect.bottom),	// LB
					CPoint(rect.left,rect.top)};	// LT

	BOOL bResult = pDc->Polyline(pts,5);
    pDc->SetROP2(nOldMode);
	return bResult;
}

////////////////////////////////////////////////////////////////////////
// draw and delete borderlines 
void CHScr2ClpDlg::OnMouseMove(UINT nFlags, CPoint point) 
{
	if( m_bIsTrackingMouseMove)
	{
		CClientDC dcScrn(this);
		InvertRectLine(&dcScrn,m_ptFirst,m_ptLast); // delete 
		m_ptLast = point;
		InvertRectLine(&dcScrn,m_ptFirst,m_ptLast); // draw 
	}
	
	CDialog::OnMouseMove(nFlags, point);
}

//////////////////////////////////////////////////////////////////////
// Copy Rect(ptFirst, ptLast) image to clipboard
BOOL CHScr2ClpDlg::CopyRect2Clipboard()
{
	CRect rect(m_ptFirst,m_ptLast);
	rect.NormalizeRect();	
	if(rect.IsRectEmpty() || rect.IsRectNull())
		return FALSE;	

	//CDC *pDc = GetWindowDC();//include Non-Client area.
	CClientDC dcScrn(this);
	CDC memDc;
	if(!memDc.CreateCompatibleDC(&dcScrn))
		return FALSE;	
	CBitmap bitmap;
	if( !bitmap.CreateCompatibleBitmap(&dcScrn,rect.Width(),rect.Height()))
		return FALSE;
	CBitmap* pOldBitmap = memDc.SelectObject(&bitmap);
	memDc.BitBlt(0,0,rect.Width(),rect.Height(),&dcScrn,rect.left ,rect.top ,SRCCOPY );		
	if(OpenClipboard())
	{
		EmptyClipboard();
		SetClipboardData(CF_BITMAP,bitmap.GetSafeHandle());
		CloseClipboard();
	}
	memDc.SelectObject(pOldBitmap);
	return TRUE;
}

//////////////////////////////////////////////////////////////////////
// show flashing icon
void CHScr2ClpDlg::OnTimer(UINT nIDEvent) 
{
	if( nIDEvent == ID_RecordingTimer)
	{
		static int nIndex = 0;
		++nIndex;
		nIndex %= 2;
		CBitmap cBm;
		cBm.LoadBitmap((nIndex)?IDB_BITMAP1:IDB_BITMAP2);
		BITMAP bBm;
		cBm.GetBitmap(&bBm);
		CClientDC dcScr(this);
		CRect rect;
		GetClientRect(&rect);
		CDC memDc;
		memDc.CreateCompatibleDC(&dcScr);
		CBitmap* pOldBitmap = memDc.SelectObject(&cBm);
		dcScr.BitBlt(rect.right-(bBm.bmWidth*2),rect.bottom-(bBm.bmHeight*2),
					 bBm.bmWidth,bBm.bmHeight,&memDc,0,0,SRCERASE);
		memDc.SelectObject(pOldBitmap);
	}	
	CDialog::OnTimer(nIDEvent);
}

//////////////////////////////////////////////////////////////////
// show/hide msg on panel
void CHScr2ClpDlg::ShowMsg(BOOL bShown)
{	
	if(bShown)
	{
		GetDlgItem(IDC_Mail)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_STATIC1)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_STATIC2)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_STATIC3)->ShowWindow(SW_SHOW);
	}
	else
	{		
		GetDlgItem(IDC_Mail)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_STATIC1)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_STATIC2)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_STATIC3)->ShowWindow(SW_HIDE);
	}
}
