// HScr2ClpDlg.h : header file
//

#if !defined(AFX_HSCR2CLPDLG_H__27C82576_AA32_4769_A2F2_F3E0DCB7B344__INCLUDED_)
#define AFX_HSCR2CLPDLG_H__27C82576_AA32_4769_A2F2_F3E0DCB7B344__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include "HyperLink.h"
/////////////////////////////////////////////////////////////////////////////
// CHScr2ClpDlg dialog

class CHScr2ClpDlg : public CDialog
{
// Construction
public:
	void ShowMsg(BOOL bShown = TRUE);
	BOOL CopyRect2Clipboard();
	BOOL InvertRectLine(CDC* pDc, CPoint ptFrom, CPoint ptTo);
	CHScr2ClpDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CHScr2ClpDlg)
	enum { IDD = IDD_HSCR2CLP_DIALOG };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CHScr2ClpDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	UINT m_uintRecording;
	CRect m_rectWnd;
	DWORD m_dwWndStyle;
	BOOL m_bIsTrackingMouseMove;
	CPoint m_ptLast;
	CPoint m_ptFirst;
	BOOL m_bIsEnableCapture;
	WINDOWPLACEMENT m_wndPlace;
	HICON m_hIcon;
	CHyperLink m_Mail;
	
	afx_msg BOOL OnClickPrintScreen(WPARAM wParam, LPARAM lParam);
	// Generated message map functions
	//{{AFX_MSG(CHScr2ClpDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnClose();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnTimer(UINT nIDEvent);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_HSCR2CLPDLG_H__27C82576_AA32_4769_A2F2_F3E0DCB7B344__INCLUDED_)
